/****************************************************************************
 Copyright (c) 2017-2018 Xiamen Yaji Software Co., Ltd.

 http://www.cocos2d-x.org

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 ****************************************************************************/

#include "HelloWorldScene.h"

#include <iostream>
#include <openssl/aes.h>
#include <openssl/evp.h>
#include <openssl/rsa.h>
#include <openssl/pem.h>
#include <openssl/ssl.h>
#include <openssl/bio.h>
#include <openssl/err.h>
#include <assert.h>
USING_NS_CC;

using namespace nowgg;
using namespace std;
using namespace cocos2d;

std::string publicKey = "-----BEGIN PUBLIC KEY-----\n"\
"MIIBIjANBgkqhkiG9w0BAQEFAAOCAQ8AMIIBCgKCAQEAwB0JndWcatG1vYeCxhM/\n"\
"DPspZD+/A4MqbYTT5e4NL9u+rM7j4dVgi1MymsTf4yWrg5ErugtrZs+g+Iz0gaYu\n"\
"NJX8JH6fw7Ikze2OWs6yLh9IVw9hIAuJyb8Q5gkaquqAjXK+W3q/R6O0im3whmAZ\n"\
"XbTq9kCnXOo5Hs8u7TcwX+9mlFH0GZyJeF4lcKcTekX3Ayj3LMatoiLRPP3pJEPS\n"\
"Xg/Q9wVzivFvcEzBla+EFUy6HFqZ/jyM99NkcCaj1CkEwZyjmtGPLKLQxwUI08N1\n"\
"N7hI2VIqW4AFkHSnioeIt8pWzotrzfTXZWwrZJB5h3WWsXgUfZpPUdSnz+muXNqM\n"\
"iwIDAQAB\n"\
"-----END PUBLIC KEY-----\n";

std::string privateKey = "-----BEGIN RSA PRIVATE KEY-----\n"\
"MIIEvQIBADANBgkqhkiG9w0BAQEFAASCBKcwggSjAgEAAoIBAQDAHQmd1Zxq0bW9\n"\
"h4LGEz8M+ylkP78DgypthNPl7g0v276szuPh1WCLUzKaxN/jJauDkSu6C2tmz6D4\n"\
"jPSBpi40lfwkfp/DsiTN7Y5azrIuH0hXD2EgC4nJvxDmCRqq6oCNcr5ber9Ho7SK\n"\
"bfCGYBldtOr2QKdc6jkezy7tNzBf72aUUfQZnIl4XiVwpxN6RfcDKPcsxq2iItE8\n"\
"/ekkQ9JeD9D3BXOK8W9wTMGVr4QVTLocWpn+PIz302RwJqPUKQTBnKOa0Y8sotDH\n"\
"BQjTw3U3uEjZUipbgAWQdKeKh4i3ylbOi2vN9NdlbCtkkHmHdZaxeBR9mk9R1KfP\n"\
"6a5c2oyLAgMBAAECggEAJ0KH4ZJyyb2bh2T3C6WJQAzf05XXYk9ez0zSxO1WEo60\n"\
"s7oABfnGJhLVh51uJ4xeNZ/oMLf+td7+hWzA1vHwBV0VTxv1aFeyf8bpTZNqBFTu\n"\
"QqRo89SHzwvV1zzLD1ym8sEdN7Ko/mntDlETU1K2PFkpnzNtQGa5T5uFeoLJxwDZ\n"\
"tTwGe/FzbQxLWYeCdwGhohveV/dpD/PzqAU+3NMk/latEfc5G6bUMXTlDfF0+bPo\n"\
"xltHatzxvDuqvfDNdZ/Wz4k+BhugpsaAgl9LkRfV78qNUxyH1XSwmYOhMp/5vmAz\n"\
"WpayPf8unYl/ZL9TPNwRpVPBXzjT2oeUJo647PJoGQKBgQDuMsfrJpLzqWRAeoZh\n"\
"OA/X8JZYeTdR/SxeAHSG+Z+TEHoEdPiCy6LonCCjkArNHu6fLW0UAx9zAMh5QtuK\n"\
"n6l4BkLjuL6QufKT0/eYGyFyKPSMo1hyDB5HtiFH0vmfKeBgVorU9z5KleMtenBI\n"\
"M5Y0EWcDU7BoWqCeV4uG8M+vNQKBgQDOeI7gVOyBSgVzdo973j2tsMYHeI7v2dom\n"\
"KuBzuz4LtDKp11pQeZQRbByMX3i73yozR7HBuuHVzKh/r0fItLZcmC3QVX51xZqi\n"\
"H+r6ZTDG/PDJKGNKSZlm4M0UyJAaewyLxp5/PPyJFrcY5kUfQswqYghWZZDsRcsu\n"\
"YKsUmcIEvwKBgBC4/fITVjPHC6O/Nlny7qHRYSy67dhStt+uln+3XK2ddYOElsHP\n"\
"/BLqixwQi8GUz1nbfZHvGjEft/NTb0hPJz2m6uFD4hUVCOO5+OLz3KhAGdMZ0KbJ\n"\
"FQMh1TpOpHm5HeiFit+ir/vahAV4WBOpk3z6T8obAQKCgk47hS8nDt2VAoGAGy9q\n"\
"eIUWAsvxPcuthryzWEw/Nrqb7166x2270eEkgTv/s7ckMBZh9Y1LkPv9FJeEoe3d\n"\
"rMljdNgWk4FLrVSF8lkjJxwqo20aOCCFuuRZ8MlbFtFXiW95YD9XIVZrCuGKvFix\n"\
"g8VO5unzv7aKAVy1LxtrR5zl4QYrg3a87+By2FcCgYEAgLIqQECmpmh5WdFPGeVO\n"\
"PbheI11Ma6btK/BJPgyErTYb7akCT3c99TvNHGkCjlrtng4NU+pnzFDwAYGxerQ3\n"\
"oZDqhS0yCmCuBXAUphu2im5eYXHlUkSOgtfFJqaI41wBxO8LWcHYoqr6tnBwzquS\n"\
"oEPeF06BKKRxYYURQ/SVuYw=\n"\
"-----END RSA PRIVATE KEY-----\n\0";

Scene* HelloWorld::createScene()
{
    return HelloWorld::create();
}

// Print useful error message instead of segfaulting when files are not there.
static void problemLoading(const char* filename)
{
    printf("Error while loading: %s\n", filename);
    printf("Depending on how you compiled you might have to add 'Resources/' in front of filenames in HelloWorldScene.cpp\n");
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
    //////////////////////////////
    // 1. super init first
    if ( !Scene::init() )
    {
        return false;
    }

    NowGGSDK::setListener(this);

    mCoins = 0;
    auto visibleSize = Director::getInstance()->getVisibleSize();
    Vec2 origin = Director::getInstance()->getVisibleOrigin();
    
    LayerColor *_bgColor = LayerColor::create(Color4B(255, 255, 255, 255));
    this->addChild(_bgColor , -10);

    auto item2 = MenuItemImage::create("PinkButtonIAPInit.png", "PinkButtonIAPInitPressed.png", CC_CALLBACK_1(HelloWorld::NowGGIAPInit, this) );
    auto item3 = MenuItemImage::create("PinkButtonLogin.png", "PinkButtonLoginPressed.png", CC_CALLBACK_1(HelloWorld::NowGGLogin, this) );
    item2->setAnchorPoint(Vec2(0, 1));
    item3->setAnchorPoint(Vec2(0, 1));
    auto menu = Menu::create(item2, item3, nullptr);
    menu->alignItemsVertically();
    menu->setPosition(Vec2(40, visibleSize.height - 70));
    menu->setAnchorPoint(Vec2(0, 1));
    this->addChild(menu, 1);

    
    auto sprite = Sprite::create("NowGGIcon.png");
    if (sprite == nullptr) {
        problemLoading("'NowGGIcon.png'");
    } else {
        sprite->setAnchorPoint(Vec2(0, 1));
        sprite->setPosition(Vec2(40, visibleSize.height));
        this->addChild(sprite, 0);
    }
    
    mLabel = Label::createWithTTF("status :- \n", "fonts/arial.ttf", 8.0f);
    mLabel->setPosition(150, visibleSize.height - 30);
    mLabel->setDimensions(180, 0);

    mLabel->setAnchorPoint(Vec2(0, 1));
    mLabel->setTextColor(Color4B(0, 0, 0, 255));
    this->addChild(mLabel, 0);

    mCoinsLabel = Label::createWithTTF("Coins :- \n", "fonts/arial.ttf", 8.0f);
    mCoinsLabel->setPosition(350, visibleSize.height - 30);
    mCoinsLabel->setAnchorPoint(Vec2(0, 1));
    mCoinsLabel->setTextColor(Color4B(0, 0, 0, 255));
    this->addChild(mCoinsLabel, 0);

    _listView = ui::ListView::create();
    // set list view ex direction
    _listView->setDirection(ui::ScrollView::Direction::HORIZONTAL);
    _listView->setBounceEnabled(false);
    // _listView->setBackGroundImage("green_edit.png");
    _listView->setGlobalZOrder(200);
    _listView->setAnchorPoint(Vec2(0, 1));
    _listView->setBackGroundImageScale9Enabled(true);
    _listView->setContentSize(Size(320.0f, 120.0f));
    _listView->setPosition(Vec2(50, visibleSize.height/2 + 20));
    _listView->setScrollBarPositionFromCorner(Vec2(7, 7));
    this->addChild(_listView);

    // create model
    cocos2d::ui::Button* default_button = cocos2d::ui::Button::create("backtotoppressed.png", "backtotopnormal.png");
    default_button->setName("Buy");
    default_button->setTitleText("Buy");

    cocos2d::ui::Button* default_button2 = cocos2d::ui::Button::create("coins1000.png", "coins1000.png");
    default_button2->setName("Coins");
    default_button2->setTouchEnabled(false);

    auto price = cocos2d::ui::Text::create();
    price->setString("$2");
    price->setName("Price");
    price->setFontSize(8);
    price->setColor(cocos2d::Color3B::WHITE); // default seleted item
    price->setTouchEnabled(false);

    auto name = cocos2d::ui::Text::create();
    name->setString("Name");
    name->setName("Name");
    name->setFontSize(8);
    name->setColor(cocos2d::Color3B::WHITE); // default seleted item
    name->setTouchEnabled(false);

    auto description = cocos2d::ui::Text::create();
    description->setString("Description");
    description->setName("Description");
    description->setFontSize(7);
    description->setColor(cocos2d::Color3B::WHITE); // default seleted item
    description->setTouchEnabled(false);
    
    default_item = cocos2d::ui::Layout::create();
    default_item->setTouchEnabled(true);
    default_item->setContentSize(Size(90.0f, 120.0f));
    default_item->setBackGroundColorType(cocos2d::ui::Layout::BackGroundColorType::SOLID);
    default_item->setBackGroundColor(Color3B(72,66,91));
    default_button->setPosition(Vec2(default_item->getContentSize().width / 2.0f, 15.0f));

    default_button2->setPosition(Vec2(default_item->getContentSize().width / 2.0f, 60.0f));
    price->setPosition(Vec2(default_item->getContentSize().width / 2.0f, 37.0f));
    name->setPosition(Vec2(default_item->getContentSize().width / 2.0f, 105.0f));
    description->setPosition(Vec2(default_item->getContentSize().width / 2.0f, 90.0f));
    default_item->addChild(default_button);
    default_item->addChild(default_button2);
    default_item->addChild(price);
    default_item->addChild(name);
    default_item->addChild(description);

    // set model
    _listView->setItemModel(default_item);
    
    // set all items layout gravity
    _listView->setGravity(cocos2d::ui::ListView::Gravity::CENTER_VERTICAL);
    return true;
}

void HelloWorld::onPurchaseUpdated(const vector<Product*> products)
{
    // mCoins = 0;
    for (int i = 0; i < products.size(); i++) {
        __android_log_print(ANDROID_LOG_DEBUG, "TAG", "HelloWorld::onPurchaseUpdated : %s \n", products.at(i)->signature.c_str());
        if (products.at(i)->productId.compare("coin1") == 0)
        {
            mCoins = mCoins + 200;
        } else if (products.at(i)->productId.compare("coin2") == 0) {
            mCoins = mCoins + 400;
        } else if (products.at(i)->productId.compare("coin3") == 0) {
            mCoins = mCoins + 600;
        }
        
        
        __android_log_print(ANDROID_LOG_DEBUG, "TAG", "HelloWorld::onPurchaseUpdates json: %s \n", products.at(i)->originalJson.c_str());
        bool valid = VerifyPurchaseLocally(publicKey, products.at(i)->originalJson, products.at(i)->signature.c_str());
        __android_log_print(ANDROID_LOG_DEBUG, "TAG", "HelloWorld::verification: %d \n", valid);
        VerifyValidSignatureOnBackend(products.at(i)->originalJson, products.at(i)->signature.c_str());
        NowGGSDK::consume(products.at(i)->purchaseToken);
    }
    cocos2d::Director::getInstance()->getScheduler()->performFunctionInCocosThread([=](){
        mCoinsLabel->setString("Coins :- " + std::to_string(mCoins));
    });
}

void HelloWorld::onPurchaseCancelled(int code, string msg)
{
    __android_log_print(ANDROID_LOG_DEBUG, "TAG", "HelloWorld::onPurchaseCancelled called : %d  : %s \n", code, msg.c_str());
}

void HelloWorld::onLoginSuccess(string email, string token, string hostUrl)
{
    __android_log_print(ANDROID_LOG_DEBUG, "TAG", "HelloWorld::onLoginSuccess called");
    __android_log_print(ANDROID_LOG_DEBUG, "TAG", "HelloWorld::onLoginSuccess called : %s  : %s \n", email.c_str(), token.c_str());
    string emailString = "Login Success : " + email;
    mLabel->setString(emailString);
    VerifyToken(token, "zBC1LCs7s7IuZzxQP9oO$$01FVCMAVCTZWJKCRPY4EH339SG");
}

void HelloWorld::onLoginFailed(int code, string errorMsg)
{
    __android_log_print(ANDROID_LOG_DEBUG, "TAG", "HelloWorld::onLoginFailed called : %d  : %s \n", code, errorMsg.c_str());
    mLabel->setString(string("Login failed  : %s", errorMsg.c_str()));
}



void HelloWorld::onPurchaseConsumed(string token)
{
    __android_log_print(ANDROID_LOG_DEBUG, "TAG", "HelloWorld::onPurchaseConsumed called : %s \n", token.c_str());
}

void HelloWorld::onInitialized(bool success)
{
    __android_log_print(ANDROID_LOG_DEBUG, "TAG", "onInitialized called : %d \n", success);
    // after successful init you can get the product details
    if (success)
    {
        cocos2d::Director::getInstance()->getScheduler()->performFunctionInCocosThread([=]() {
            mLabel->setString(mLabel->getString() + "NowGGIAP init success\n");
            vector<SkuDetails*> skuDetails =  NowGGSDK::getProductDetails();
            if (skuDetails.size() > 0) {
                mLabel->setString(mLabel->getString() + "Successfully got product details\n");
            }

            __android_log_print(ANDROID_LOG_DEBUG, "TAG", "onInitialized 1   : %d", skuDetails.size());
            //initial the data
            for (int i = 0; i < skuDetails.size(); i++){
                cocos2d::ui::Widget* item = default_item->clone();
                item->setTag(i);
                cocos2d::ui::Text* price = (cocos2d::ui::Text*)item->getChildByName("Price");
                price->setString(skuDetails.at(i)->price.c_str());
                cocos2d::ui::Text* title = (cocos2d::ui::Text*)item->getChildByName("Name");
                title->setString(skuDetails.at(i)->title.c_str());
                cocos2d::ui::Text* description = (cocos2d::ui::Text*)item->getChildByName("Description");
                description->setString(skuDetails.at(i)->description.c_str());

                cocos2d::ui::Button* buyButton = (cocos2d::ui::Button*)item->getChildByName("Buy");
                SkuDetails *details = skuDetails.at(i);
                buyButton->addClickEventListener([this, details](Ref*)
                {
                    __android_log_print(ANDROID_LOG_DEBUG, "TAG", "click works %s", details->productId.c_str());
                    NowGGSDK::purchase(details->productId, "inapp");
                });

                _listView->pushBackCustomItem(item);    
            }
            
            // set items margin
            float spacing = 4;
            _listView->setItemsMargin(spacing);
            int _itemTemplateWidth = default_item->getContentSize().width;
            this->_reuseItemOffset = (_itemTemplateWidth + spacing) * skuDetails.size();
            _listView->forceDoLayout();
            float totalWidth = _itemTemplateWidth * skuDetails.size() + (skuDetails.size() - 1) * 4;
            _listView->getInnerContainer()->setContentSize(Size(totalWidth, _listView->getInnerContainerSize().height));
            //update listview data
            this->scheduleUpdate();
        });
        
    } else {
        mLabel->setString(mLabel->getString() + "NowGGIAP init failed\n");
    }
}

void HelloWorld::NowGGIAPInit(cocos2d::Ref* pSender)
{
    
    bool isIAPAvailable = NowGGSDK::isNowGGIapAvailable();
    if (isIAPAvailable)
    {
        mLabel->setString("NowGGIAP is available\n");
        vector<string> productIds {"coin1", "coin2", "coin3"};
        
        NowGGSDK::init("593", productIds);
    } else {
        mLabel->setString("NowGGIAP not available\n");
    }
}

void HelloWorld::NowGGLogin(cocos2d::Ref* pSender)
{
    NowGGSDK::login("zBC1LCs7s7IuZzxQP9oO$$01FVCMAVCTZWJKCRPY4EH339SG");
}

void HelloWorld::VerifyToken(string token, string client_id)
{
    __android_log_print(ANDROID_LOG_DEBUG, "TAG", "VerifyToken called : %s \n", token.c_str());

    cocos2d::network::HttpRequest* request = new cocos2d::network::HttpRequest();
    request->setUrl("https://now.gg/accounts/oauth2/v1/verify-token");
    std::vector<std::string> headers;
    headers.push_back("Content-Type:application/x-www-form-urlencoded");
    request->setHeaders(headers);
    request->setRequestType(cocos2d::network::HttpRequest::Type::POST);
    request->setResponseCallback([&,this](network::HttpClient* sender, network::HttpResponse* response)
        {
            if (!response->isSucceed()) {
                __android_log_print(ANDROID_LOG_DEBUG, "TAG", "VerifyToken failed \n");
                return;
            }
            __android_log_print(ANDROID_LOG_DEBUG, "TAG", "VerifyToken success \n");
            std::vector<char>* buffer = response->getResponseData();

            char* json = (char*)malloc(buffer->size() + 1);
            std::string s2(buffer->begin(), buffer->end());
            strcpy(json, s2.c_str());
            __android_log_print(ANDROID_LOG_DEBUG, "TAG", "VerifyToken response: %s \n", json);
            cocos2d::Director::getInstance()->getScheduler()->performFunctionInCocosThread([=]() {
                mLabel->setString(mLabel->getString() + "\n" + json + "\n");
            });
            printf("\n");
        });

    string data = "token_type=id_token&token=" + token + "&client_id=zBC1LCs7s7IuZzxQP9oO$$01FVCMAVCTZWJKCRPY4EH339SG";
    __android_log_print(ANDROID_LOG_DEBUG, "TAG", "VerifyToken data:%s \n", data.c_str());
    request->setRequestData(data.c_str(), strlen(data.c_str()));
    cocos2d::network::HttpClient::getInstance()->send(request);
    request->release();
}

