/****************************************************************************
 Copyright (c) 2017-2018 Xiamen Yaji Software Co., Ltd.
 
 http://www.cocos2d-x.org
 
 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:
 
 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.
 
 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
 ****************************************************************************/

#ifndef __HELLOWORLD_SCENE_H__
#define __HELLOWORLD_SCENE_H__

#include "cocos2d.h"
#include "../proj.android/app/jni/nowggsdk/include/nowgg_sdk.h"
#include "../cocos/ui/UIListView.h"
#include "../cocos/ui/CocosGUI.h"
#include "network/HttpClient.h"

using namespace cocos2d;

class HelloWorld : public cocos2d::Scene, public nowgg::NowGGSDKListener
{
public:
    static cocos2d::Scene* createScene();

    virtual bool init();
    
    // a selector callback
    void menuCloseCallback(cocos2d::Ref* pSender);

    void NowGGIAPInit(cocos2d::Ref* pSender);
    void NowGGLogin(cocos2d::Ref* pSender);
    void VerifyToken(string token, string client_id);
    void onHttpRequestCompleted(cocos2d::network::HttpClient* sender, cocos2d::network::HttpResponse* response);
    Label *mLabel;
    Label *mCoinsLabel;
    int _reuseItemOffset;
    ui::ListView* _listView;
    cocos2d::ui::Layout *default_item;
    int mCoins;
    // implement the "static create()" method manually
    CREATE_FUNC(HelloWorld);

private:
    virtual void onInitialized(bool success) override;
    virtual void onPurchaseUpdated(const vector<nowgg::Product*> p) override;
    virtual void onPurchaseCancelled(int code, string msg) override;
    virtual void onPurchaseConsumed(string token) override;
    virtual void onLoginSuccess(string email, string token, string hostUrl) override;
    virtual void onLoginFailed(int code, string errorMsg) override;
};

bool VerifyPurchaseLocally(std::string publicKey, std::string plainText, const char* signatureBase64);
void VerifyValidSignatureOnBackend(std::string originalJson, std::string signature);
#endif // __HELLOWORLD_SCENE_H__
